/**
 * 
 */
package outsourced.explicit;

class StateC extends State {

	private State next = null;

	protected StateC(StateMachine m) {
		super(m);
	}

	@Override
	protected void x() {
		next = new StateD(m);
	}

	@Override
	protected State next() {
		return next;
	}

	@Override
	protected void entry() {
		entryC();
	}

	private void entryC() {

	}

	@Override
	public String toString() {
		return "C";
	}
}