package test;

import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

public abstract class AbstractStateMachineTest {
	protected abstract IStateMachine getAutomat();

	private IStateMachine a = null;

	@Before
	public void setUp() {
		a = getAutomat();

	}

	@Test
	public void testXXX() {
		a.x();
		a.x();
		a.x();
		assertEquals("ACDENDE", a.getPath());
	}

	@Test(expected = IllegalStateException.class)
	public void testXXXX() {
		a.x();
		a.x();
		a.x();
		a.x();
	}

	@Test
	public void testYXXX() {
		a.y();
		a.x();
		a.x();
		a.x();
		assertEquals("ABCDENDE", a.getPath());
	}

	@Test
	public void testYYYX() {
		a.y();
		a.y();
		a.y();
		a.x();
		assertEquals("ABDCD", a.getPath());
	}

	@Test(expected = IllegalStateException.class)
	public void testXY() {
		a.x();
		a.y();
	}
}
