/**
 * 
 */
package outsourced.explicit;

class StateA extends State {

	private State next = null;

	protected StateA(StateMachine m) {
		super(m);
	}

	@Override
	protected void x() {
		next = new StateC(m);
	}

	@Override
	protected void y() {
		next = new StateB(m);
	}

	@Override
	protected State next() {
		return next;
	}

	@Override
	public String toString() {
		return "A";
	}

}