package outsourced.explicit;

import test.IStateMachine;

public class StateMachine implements IStateMachine {

	private State current = new StateA(this);

	private String path = "";

	public StateMachine() {
		path += current.toString();
	}

	public void x() {
		current.x();
		current.makeTransition();
	}

	public void y() {
		current.y();
		current.makeTransition();
	}

	protected void setState(State s) {
		this.current = s;
		path += s.toString();
	}

	@Override
	public String getPath() {
		return path;
	}
}
